package de.tudarmstadt.maki.simonstrator.api.web;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;

import de.tudarmstadt.maki.simonstrator.api.web.approach.Approach;
import de.tudarmstadt.maki.simonstrator.api.web.parameter.Parameter;

@XmlAccessorType(XmlAccessType.FIELD)
public class Scenario {
    @XmlElement(name = "name")
    private String _name;

    @XmlElement(name = "config")
    private String _config;

    @XmlElementWrapper(name = "approaches")
    @XmlElement(name = "approach")
    List<Approach> _approaches = new ArrayList<>();

    @XmlElementWrapper(name = "parameters")
    @XmlElement(name = "parameter")
    List<Parameter> _parameters = new ArrayList<>();

    public Scenario() {
    }

    public Scenario(String pName, String pConfig) {
        _name = pName;
        _config = pConfig;
    }

    public void setName(String pName) {
        _name = pName;
    }

    public void setConfig(String pConfig) {
        _config = pConfig;
    }

    public String getName() {
        return _name;
    }

    public String getConfig() {
        return _config;
    }

    public void addApproach(Approach pApproach) {
        _approaches.add(pApproach);
    }

    public List<Approach> getApproaches() {
        return _approaches;
    }

    public void addParameter(Parameter pParameter) {
        _parameters.add(pParameter);
    }

    public List<Parameter> getParameters() {
        return _parameters;
    }

    public Approach getApproach(String pName) {
        for (Approach approach : _approaches) {
            if (approach.getName().equals(pName)) {
                return approach;
            }
        }
        return null;
    }

    public Parameter getParameter(String pName) {
        for (Parameter parameter : _parameters) {
            if (parameter.getName().equals(pName)) {
                return parameter;
            }
        }
        return null;
    }
}